/**
 * Copyright (C) 2010-2012 Agrosense info@agrosense.eu
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.task.field;

import java.util.logging.Logger;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author Maciek Dulkiewicz <maciek.dulkiewicz@ordina.nl>
 */
//FIXME: move task and controller logic out of the panel and use the extracted panel (in task-core) directly
public class WorkWidthPanel extends nl.cloudfarming.client.task.WorkWidthPanel implements ChangeListener {

    //String values are used because an array of double values is not displayed
    //properly by the spinner. String values are used that are later converted
    //to double values
    private static final String MIN_WORK_WIDTH = Double.toString(FieldTask.MIN_WORK_WIDTH);
    private static final String[] DEFAULT_WORK_WIDTH_VALUES = {MIN_WORK_WIDTH, "10.0", "20.0", "25.0"};
    private static final Logger LOGGER = Logger.getLogger(WorkWidthPanel.class.getCanonicalName());

    private FieldTask task;

    /**
     * Creates new form WorkWidthPanel
     */
    public WorkWidthPanel() {
       super(DEFAULT_WORK_WIDTH_VALUES);
       getWorkWidthSpinner().addChangeListener(this);
    }

    public void setTask(FieldTask task) {
        this.task = task;
        setWorkWidthValue(task.getWorkWidth());
    }

    /**
     * When the value of the spinner changes, update the work width value of the
     * task contained by this panel.
     *
     * @param e event fired by the workWidthSpinner
     */
    @Override
    public void stateChanged(ChangeEvent e) {
        task.setWorkWidth(getWorkWidthValue());
    }

}
